// OutOfBandMessage.h
/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/

#ifndef OutOfBandMessageH
#define OutOfBandMessageH

#include "Int32Message.h"
class DLList;

class OutOfBandMessage : public Int32Message
{
public:
    OutOfBandMessage();
    virtual ~OutOfBandMessage() {}
    virtual int32  toBuffer(char **buffer) const;
    virtual int32  fromBuffer(const char **buffer);
    virtual int32  fromBufferSwitch(const char **buffer);
    virtual void print() const;
    static void *operator new(size_t size);
    void operator delete(void *p, size_t size);
protected:
    OutOfBandMessage(messageType type);
private:
    static DLList *pFreeList;
    // Disallow copy constructor, assignment operator 
    OutOfBandMessage(const OutOfBandMessage&);
    OutOfBandMessage& operator=(const OutOfBandMessage&);
};

#endif /*OutOfBandMessageH*/
